Index: less/line.c
diff -u less/line.c:1.1.1.13 less/line.c:1.85
--- less/line.c:1.1.1.13	Sun Oct 29 02:19:10 2000
+++ less/line.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -27,6 +33,8 @@
 public int cshift;		/* Current left-shift of output line buffer */
 public int hshift;		/* Desired left-shift of output line buffer */
 
+static CHARSET charset[LINEBUF_SIZE];
+				/* Extension of linebuf to hold character set */
 static char attr[LINEBUF_SIZE];	/* Extension of linebuf to hold attributes */
 static int curr;		/* Index into linebuf */
 static int column;		/* Printable length, accounting for
@@ -36,9 +44,12 @@
 static int lmargin;		/* Left margin */
 static char pendc;
 static POSITION pendpos;
+static POSITION lastpos;
 static char *end_ansi_chars;
 
+static int pwidth();
 static int do_append();
+static int real_do_append();
 
 extern int bs_mode;
 extern int tabstop;
@@ -53,6 +64,8 @@
 extern int bl_s_width, bl_e_width;
 extern int so_s_width, so_e_width;
 extern int sc_width, sc_height;
+extern IFILE curr_ifile;
+
 extern int utf_mode;
 extern POSITION start_attnpos;
 extern POSITION end_attnpos;
@@ -72,13 +85,24 @@
  * Rewind the line buffer.
  */
 	public void
-prewind()
+prewind(pos)
+	POSITION pos;
 {
 	curr = 0;
 	column = 0;
 	overstrike = 0;
 	is_null_line = 0;
 	pendc = '\0';
+#if ISO
+	/*
+	 * If an input string is not contigious string of the last string,
+	 * clear all status in multi bytes character buffering routine.
+	 */
+	if (lastpos != pos || pos < 0)
+		init_multi(get_mulbuf(curr_ifile));
+	else
+		clear_multi(get_mulbuf(curr_ifile));
+#endif
 	lmargin = 0;
 	if (status_col)
 		lmargin += 1;
@@ -131,8 +155,10 @@
 	{
 		sprintf(&linebuf[curr], "%*d", LINENUM_WIDTH, lno);
 		column += LINENUM_WIDTH;
-		for (i = 0;  i < LINENUM_WIDTH;  i++)
-			attr[curr++] = 0;
+		for (i = 0;  i < LINENUM_WIDTH;  i++) {
+			charset[curr] = ASCII;
+			attr[curr++] = AT_NORMAL;
+		}
 	}
 	/*
 	 * Append enough spaces to bring us to the lmargin.
@@ -140,6 +166,7 @@
 	while (column < lmargin)
 	{
 		linebuf[curr] = ' ';
+		charset[curr] = ASCII;
 		attr[curr++] = AT_NORMAL;
 		column++;
 	}
@@ -177,13 +204,67 @@
 	int shift;
 {
 	int i;
-	int real_shift;
+	int j;
+	int real_shift;			/* exact columns to shift */
+	int exact_length;		/* exact bytes to shift */
+	int padding;			/* columns for padding */
 
 	if (shift > column - lmargin)
 		shift = column - lmargin;
 	if (shift > curr - lmargin)
 		shift = curr - lmargin;
 
+#if ISO
+	/*
+	 * Calculate exact bytes to shift.
+	 *
+	 * We would like to shift linebuf, charset, and attr by "shift"
+	 * characters.  The problem is we don't know how many bytes we
+	 * need to shift.  So, calculate it first.
+	 */
+	padding = 0;
+	real_shift = 0;
+	exact_length = 0;
+	/*
+	 * Skip rest of multi bytes character.
+	 */
+	for (j = lmargin; j < curr && pwidth(linebuf[j], charset[j], attr[j]) == 0; j++)
+	{
+		padding++;
+		exact_length++;
+	}
+	/*
+	 * Calculate how many bytes we need to shift.
+	 */
+	for (; j < curr && real_shift < shift; j++)
+	{
+		real_shift += pwidth(linebuf[j], charset[j], attr[j]);
+		exact_length++;
+	}
+	/*
+	 * Skip following rest bytes of a last multi bytes character.
+	 */
+	for (; j < curr && pwidth(linebuf[j], charset[j], attr[j]) == 0; j++)
+	{
+		exact_length++;
+	}
+
+	/*
+	 * Put characters.
+	 */
+	for (i = 0;  i < padding;  i++)
+	{
+		linebuf[lmargin + i] = ' ';
+		charset[lmargin + i] = ASCII;
+		attr[lmargin + i] = AT_NORMAL;;
+	}
+	for (i = 0;  i < curr - exact_length;  i++)
+	{
+		linebuf[lmargin + i + padding] = linebuf[lmargin + i + exact_length];
+		charset[lmargin + i + padding] = charset[lmargin + i + exact_length];
+		attr[lmargin + i + padding] = attr[lmargin + i + exact_length];
+	}
+#else
 	if (!utf_mode)
 		real_shift = shift;
 	else
@@ -197,6 +278,8 @@
 		linebuf[lmargin + i] = linebuf[lmargin + i + real_shift];
 		attr[lmargin + i] = attr[lmargin + i + real_shift];
 	}
+#endif
+
 	column -= shift;
 	curr -= real_shift;
 	cshift += shift;
@@ -245,8 +328,9 @@
  * attribute sequence to be inserted, so this must be taken into account.
  */
 	static int
-pwidth(c, a)
+pwidth(c, cs, a)
 	int c;
+	int cs;
 	int a;
 {
 	register int w;
@@ -272,7 +356,11 @@
 	 * Other characters take one space,
 	 * plus the width of any attribute enter/exit sequence.
 	 */
+#if ISO
+	w = mwidth(c, cs);
+#else
 	w = 1;
+#endif
 	if (curr > 0 && attr[curr-1] != a)
 		w += attr_ewidth(attr[curr-1]);
 	if (a && (curr == 0 || attr[curr-1] != a))
@@ -286,8 +374,15 @@
 	static void
 backc()
 {
-	curr--;
-	column -= pwidth(linebuf[curr], attr[curr]);
+	/* remove garbage in the buffer. */
+	if (CSISREST(charset[curr]))
+		charset[curr] = 0;
+	/* delete the previous character. */
+	do
+	{
+		curr--;
+		column -= pwidth(linebuf[curr], charset[curr], attr[curr]);
+	} while (curr > 0 && CSISREST(charset[curr]));
 }
 
 /*
@@ -316,8 +411,9 @@
  * Append a character and attribute to the line buffer.
  */
 	static int
-storec(c, a, pos)
+storec(c, cs, a, pos)
 	int c;
+	int cs;
 	int a;
 	POSITION pos;
 {
@@ -330,18 +426,38 @@
 		 * Override the attribute passed in.
 		 */
 		a = AT_STANDOUT;
+#if ISO
+	/*
+	 * All data of multi bytes character has same position.
+	 * However search mark data position and not character position.
+	 * Thus we must check all data position of each character.
+	 */
+	else if (CSISREST(cs))
+	{
+		register int i;
+		for (i = 1; CSISREST(charset[curr - i]); i++)
+			;
+		if (is_hilited(pos - i, pos, 0))
+		{
+			for (i = curr - 1; CSISREST(charset[i]); --i)
+				attr[i] = AT_STANDOUT;
+			attr[i] = AT_STANDOUT;
+			a = AT_STANDOUT;
+		}
+	}
+#endif
 #endif
 	if (ctldisp == OPT_ONPLUS && in_ansi_esc_seq())
 		w = 0;
 	else
-		w = pwidth(c, a);
+		w = pwidth(c, cs, a);
 	if (ctldisp != OPT_ON && column + w + attr_ewidth(a) > sc_width)
 		/*
 		 * Won't fit on screen.
 		 */
 		return (1);
 
-	if (curr >= sizeof(linebuf)-2)
+	if (curr >= (int)sizeof(linebuf)-2)
 		/*
 		 * Won't fit in line buffer.
 		 */
@@ -381,6 +497,7 @@
 	/* End of magic cookie handling. */
 
 	linebuf[curr] = c;
+	charset[curr] = cs;
 	attr[curr] = a;
 	column += w;
 	return (0);
@@ -438,30 +555,56 @@
 	int c;
 	POSITION pos;
 {
+#if ISO
+	char *cbuf;
+	CHARSET *csbuf;
+	int i, j;
+
+	buffering_multi(get_mulbuf(curr_ifile), c, &cbuf, &csbuf, &i);
+	j = i;
+	while (--i >= 0)
+	{
+		if (real_do_append(*cbuf++, *csbuf++, pos))
+		{
+			set_bufbytes(get_mulbuf(curr_ifile),
+				     get_bufbytes(get_mulbuf(curr_ifile)) -
+				     (j - (i + 1)));
+			return (1);
+		}
+	}
+	return (0);
+#else
+	return (real_do_append(c, control_char(c) ? WRONGCS : ASCII, pos));
+#endif
+}
+
+	static int
+real_do_append(c, cs, pos)
+	register int c;
+	register CHARSET cs;
+	POSITION pos;
+{
 	register char *s;
 	register int a;
 
-#define	STOREC(c,a) \
-	if (storec((c),(a),pos)) return (1); else curr++
+#define	STOREC(c,cs,a) \
+	if (storec((c),(cs),(a),pos)) return (1); else curr++
 
-	if (c == '\b')
+	if (CSISWRONG(cs) && c != '\b' && c != '\t')
+		goto do_control_char;
+	if (overstrike)
 	{
-		switch (bs_mode)
+		/*
+		 * Check about multi '\b' for multi bytes character.
+		 */
+		if (c == '\b')
 		{
-		case BS_NORMAL:
-			STOREC(c, AT_NORMAL);
-			break;
-		case BS_CONTROL:
-			goto do_control_char;
-		case BS_SPECIAL:
-			if (curr == 0)
-				break;
-			backc();
-			overstrike = 1;
-			break;
+			if (linebuf[curr] == '_' && CSISASCII(charset[curr]))
+				goto do_bs_char; /* do backc on underline */
+			else
+				return (0);		/* ignore it */
 		}
-	} else if (overstrike)
-	{
+
 		/*
 		 * Overstrike the character at the current position
 		 * in the line buffer.  This will cause either 
@@ -470,17 +613,42 @@
 		 * or just deletion of the character in the buffer.
 		 */
 		overstrike = 0;
-		if ((char)c == linebuf[curr])
-			STOREC(linebuf[curr], AT_BOLD);
-		else if (c == '_')
-			STOREC(linebuf[curr], AT_UNDERLINE);
-		else if (linebuf[curr] == '_')
-			STOREC(c, AT_UNDERLINE);
-		else if (control_char(c))
+		if (CSISWRONG(cs) && control_char(c))
 			goto do_control_char;
+		if ((char)c == linebuf[curr] && charset[curr] == cs)
+			STOREC(c, cs, AT_BOLD);
+		else if (c == '_' && CSISASCII(cs))
+		{
+			STOREC(linebuf[curr], charset[curr], AT_UNDERLINE);
+#if ISO
+			while (CSISREST(charset[curr]))
+				STOREC(linebuf[curr], charset[curr],
+				       AT_UNDERLINE);
+#endif
+		} else if (linebuf[curr] == '_' && CSISASCII(charset[curr]))
+			STOREC(c, cs, AT_UNDERLINE);
 		else
-			STOREC(c, AT_NORMAL);
-	} else if (c == '\t') 
+			STOREC(c, cs, AT_NORMAL);
+	} else if (c == '\b' && CSISWRONG(cs))
+	{
+	do_bs_char:
+		switch (bs_mode)
+		{
+		case BS_NORMAL:
+			STOREC(c, cs, AT_NORMAL);
+			break;
+		case BS_CONTROL:
+			goto do_control_char;
+		case BS_SPECIAL:
+			if (curr == 0)
+				goto do_control_char;
+			if (CSISWRONG(charset[curr - 1]))
+				goto do_control_char;
+			backc();
+			overstrike = 1;
+			break;
+		}
+	} else if (c == '\t' && CSISWRONG(cs)) 
 	{
 		/*
 		 * Expand a tab into spaces.
@@ -495,11 +663,11 @@
 		case BS_SPECIAL:
 			do
 			{
-				STOREC(' ', AT_NORMAL);
+				STOREC(' ', ASCII, AT_NORMAL);
 			} while (((column + cshift - lmargin) % tabstop) != 0);
 			break;
 		}
-	} else if (control_char(c))
+	} else if (CSISWRONG(cs) && control_char(c))
 	{
 	do_control_char:
 		if (ctldisp == OPT_ON || (ctldisp == OPT_ONPLUS && c == ESC))
@@ -507,13 +675,13 @@
 			/*
 			 * Output as a normal character.
 			 */
-			STOREC(c, AT_NORMAL);
+			STOREC(c, cs, AT_NORMAL);
 		} else 
 		{
 			/*
 			 * Convert to printable representation.
 			 */
-			s = prchar(c);  
+			s = prchar(c, cs);  
 			a = binattr;
 
 			/*
@@ -525,11 +693,16 @@
 				return (1);
 
 			for ( ;  *s != 0;  s++)
-				STOREC(*s, a);
+				STOREC(*s, WRONGCS, a);
 		}
+#if ISO
+	} else if (CSISREST(cs))
+	{
+		STOREC(c, cs, attr[curr - 1]);
+#endif
 	} else
 	{
-		STOREC(c, AT_NORMAL);
+		STOREC(c, cs, AT_NORMAL);
 	}
 
 	return (0);
@@ -539,9 +712,17 @@
  * Terminate the line in the line buffer.
  */
 	public void
-pdone(endline)
+pdone(endline, pos)
 	int endline;
+	POSITION pos;
 {
+#if ISO
+	/*
+	 * Check and flush some buffering characters.
+	 */
+	(void) do_append(-1, pos);
+#endif
+
 	if (pendc && (pendc != '\r' || !endline))
 		/*
 		 * If we had a pending character, put it in the buffer.
@@ -563,11 +744,14 @@
 	if (column < sc_width || !auto_wrap || ignaw || ctldisp == OPT_ON)
 	{
 		linebuf[curr] = '\n';
+		charset[curr] = ASCII;
 		attr[curr] = AT_NORMAL;
 		curr++;
 	}
 	linebuf[curr] = '\0';
+	charset[curr] = ASCII;
 	attr[curr] = AT_NORMAL;
+	lastpos = pos;
 	/*
 	 * If we are done with this line, reset the current shift.
 	 */
@@ -581,8 +765,9 @@
  * and the character attribute in *ap.
  */
 	public int
-gline(i, ap)
+gline(i, csp, ap)
 	register int i;
+	register int *csp;
 	register int *ap;
 {
 	char *s;
@@ -593,11 +778,13 @@
 		 * If there is no current line, we pretend the line is
 		 * either "~" or "", depending on the "twiddle" flag.
 		 */
+		*csp = ASCII;
 		*ap = AT_BOLD;
 		s = (twiddle) ? "~\n" : "\n";
 		return (s[i]);
 	}
 
+	*csp = charset[i];
 	*ap = attr[i];
 	return (linebuf[i] & 0377);
 }
Index: less/main.c
diff -u less/main.c:1.1.1.16 less/main.c:1.25
--- less/main.c:1.1.1.16	Sun Oct 29 02:03:30 2000
+++ less/main.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1998-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -103,12 +109,18 @@
 	get_term();
 	init_cmds();
 	init_prompt();
+	init_planeset();
 	init_charset();
 	init_line();
 	init_option();
 	s = lgetenv("LESS");
 	if (s != NULL)
 		scan_option(save(s));
+#if ISO
+	s = lgetenv("JLESS");
+	if (s != NULL)
+		scan_option(save(s));
+#endif
 
 #define	isoptstring(s)	(((s)[0] == '-' || (s)[0] == '+') && (s)[1] != '\0')
 	while (argc > 0 && (isoptstring(*argv) || isoptpending()))
